#!/usr/bin/perl -w

##----------------------------------------------------------------------
## This code is licensed under the Big-Kazooba-Ritual license:
## 
## You may copy, modify or distribute this software provided that
## you first perform the ritual described in section a.
## 
## If you ever meet one of the authors of this work you can be asked,
## and must comply, to perform the ritual as described in section a.
## 
## a. Lift your left leg, close your eyes and jump in the air.
##    Now tap the point of your nose exactly two times with your
##    right index finger. To complete: say the words
##               "thank you Big Kazooba"
## 
##    You may open your eyes now.
## 
## The disabled may opt not to perform this ritual but have a
## volunteer perform the ritual on their behalf.
## 
## Anyone, of suited position, may opt to command any number of
## subordinates to perform the ritual instead.
## ----------------------------------------------------------------------

use strict;

# usage: buildExportFile.pl f1.hi f2.hi ... fn.hi > file.iface
# assumes ghc and egrep are in your path

while (1) {
    my $hiFile = shift or last;
    print STDERR "Reading $hiFile...\n";

    open F, "ghc --show-iface $hiFile | egrep '^__export |^__interface' |";
    my $modname = "";
    my %exports = ();
    while (<F>) {
        chomp;
        $_ =~ s/[\s]+/ /g;
        # check for module name
        if (/^__interface /) {
            $modname = $_;
            $modname =~ s/^__interface \"[^\"]+\" ([^ ]+) .*/$1/;
            print $modname;
            next;
        }

        # get rid of semicolon at end
        $_ =~ s/;//g;
        # drop first two words
        $_ =~ s/^__export[\s]+[^\s]+[\s]//;

        print ' ' . $_;
    }
    print "\n";
}
